/*
 * MFRC500Գ
 * 
 * ;MFRC500Գ
 * 
 * 								ע
 * Huafeng Lin			2011/09/22			
 * Huafeng Lin			2011/09/28			޸
 * 
 */

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Main.h"
#include "..\MFRC500\mfrc.h"
#include "KeyOption.h"
#pragma comment(lib, "..\MFRC500\MFRC500.lib")

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;

#define BUF_SIZE 16
//#define INIT_STRING_VALUE "88888888888888888888888888888888"
//---------------------------------------------------------------------------

__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

AnsiString BytesToString(BYTE* b, int len)
{
        AnsiString s;

        for (int i=0; i<len; i++)
        {
                s += IntToHex(b[i], 2);
        }

        return s;
}
//---------------------------------------------------------------------------

BYTE* HexStringToBytes(AnsiString s)
{
        if (s == NULL || s.IsEmpty())
        {
                return NULL;
        }

        AnsiString _s;

        static BYTE buf[BUF_SIZE];
        memset(buf, 0, BUF_SIZE);

        int len = s.Length() / 2;

        for (int i=0; i<len; i++)
        {
                _s = "0x";
                _s += s[i*2+1];
                _s += s[i*2+2];
                buf[i] = StrToInt(_s);
        }

        return buf;
}
//---------------------------------------------------------------------------

static BYTE* __fastcall GetInitBytes(int sec, unsigned long value)
{
        AnsiString _s;

        static BYTE buf[BUF_SIZE];
        memset(buf, 0, BUF_SIZE);

        buf[0] = value / 0x100000000;
        buf[1] = value % 0x1000000 / 0x100;
        buf[2] = value % 0x10000 / 0x100;
        buf[3] = value % 0x100;
        buf[4] = buf[0] ^ 0xFF;
        buf[5] = buf[1] ^ 0xFF;
        buf[6] = buf[2] ^ 0xFF;
        buf[7] = buf[3] ^ 0xFF;
        buf[8] = buf[0];
        buf[9] = buf[1];
        buf[10] = buf[2];
        buf[11] = buf[3];
        buf[12] = sec;
        buf[13] = sec ^ 0xFF;
        buf[14] = buf[12];
        buf[15] = buf[13];

        return buf;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Open()
{
        ButtonOpen->Enabled = false;
        ButtonClose->Enabled = true;

        char ver[15];
        memset(ver, 0, 15);
        lib_ver(ver);
        LabelSoftwareValue->Caption = ver;

        int port = ComboBoxPort->ItemIndex+1;
        int baud = ComboBoxBaud->Items->Strings[ComboBoxBaud->ItemIndex].ToInt();
        if (rc_init(port, baud))
        {
                MainRichEdit->Lines->Append("ʧܣ");
        }
        else
        {
                MainRichEdit->Lines->Append("ӳɹ");
        }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Exit()
{
        ButtonOpen->Enabled = true;
        ButtonClose->Enabled = false;
        rc_exit();

        MainRichEdit->Lines->Append("ڶϿɹ");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FindCard()
{
        AnsiString s;
        s.SetLength(10);
        unsigned long snr = 0;
        rc_card(0, &snr);
        ultoa(snr, s.c_str(), 16);
        LabelCardSNValue->Caption = s.UpperCase();

        MainRichEdit->Lines->Append("Ѱɹ");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
        ListBoxDataSector->ItemIndex = 0;
        ListBoxValueSector->ItemIndex = 0;
        Open();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
        Exit();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonOpenClick(TObject *Sender)
{
        Open();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonCloseClick(TObject *Sender)
{
        Exit();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonFindCardClick(TObject *Sender)
{
        FindCard();
        rc_beep();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonAntiCollisionClick(TObject *Sender)
{
        AnsiString s;
        s.SetLength(10);
        unsigned long snr = 0;
        rc_anticoll(&snr);
        ultoa(snr, s.c_str(), 16);
        LabelCardSNValue->Caption = s.UpperCase();

        rc_beep();

        MainRichEdit->Lines->Append("ײɹ");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonSelectCardClick(TObject *Sender)
{
        rc_select(0);
        rc_beep();

        MainRichEdit->Lines->Append("ѡ񿨲ɹ");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonHaltCardClick(TObject *Sender)
{
        rc_halt();
        rc_beep();

        MainRichEdit->Lines->Append("ֹɹ");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Menu_File_ExitClick(TObject *Sender)
{
        Close();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Menu_Help_AboutClick(TObject *Sender)
{
        MessageBox(this->Handle, "(LC) V1.0", "", MB_OK);       
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonDataBlockReadClick(TObject *Sender)
{
        FindCard();

        int sec = ListBoxDataSector->ItemIndex;
        int mode = ComboBoxDataOpPwdType->ItemIndex;
        if (mode == USEKEYA || mode == USEKEYB)
        {
                AnsiString sPassword = EditDataOpPassword->Text.Trim();
                if (!sPassword.IsEmpty())
                {
                        rc_load_key(mode, sec, HexStringToBytes(sPassword));
                }
        }
        else
        {
                rc_authentication(mode, sec);
        }

        BYTE buf[BUF_SIZE];

        memset(buf, 0, BUF_SIZE);
        rc_read(4*sec, buf);
        EditDataBlock0->Text = BytesToString(buf, BUF_SIZE);
        rc_beep();

        memset(buf, 0, BUF_SIZE);
        rc_read(4*sec+1, buf);
        EditDataBlock1->Text = BytesToString(buf, BUF_SIZE);
        rc_beep();

        memset(buf, 0, BUF_SIZE);
        rc_read(4*sec+2, buf);
        EditDataBlock2->Text = BytesToString(buf, BUF_SIZE);
        rc_beep();

        memset(buf, 0, BUF_SIZE);
        rc_read(4*sec+3, buf);
        EditDataBlock3->Text = BytesToString(buf, BUF_SIZE);
        rc_beep();

        MainRichEdit->Lines->Append("ɹ");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonDataBlockWriteClick(TObject *Sender)
{
        FindCard();
        
        int sec = ListBoxDataSector->ItemIndex;
        int mode = ComboBoxDataOpPwdType->ItemIndex;
        if (mode == USEKEYA || mode == USEKEYB)
        {
                AnsiString sPassword = EditDataOpPassword->Text.Trim();
                if (!sPassword.IsEmpty())
                {
                        rc_load_key(mode, sec, HexStringToBytes(sPassword));
                }
        }
        else
        {
                rc_authentication(mode, sec);
        }

        if (EditDataBlock0->Enabled && !EditDataBlock0->Text.IsEmpty())
        {
                rc_write(4*sec, HexStringToBytes(EditDataBlock0->Text));
                rc_beep();
        }

        if (!EditDataBlock1->Text.IsEmpty())
        {
                rc_write(4*sec+1, HexStringToBytes(EditDataBlock1->Text));
                rc_beep();
        }

        if (!EditDataBlock2->Text.IsEmpty())
        {
                rc_write(4*sec+2, HexStringToBytes(EditDataBlock2->Text));
                rc_beep();
        }

        MainRichEdit->Lines->Append("ɹ");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonDataBlockInitClick(TObject *Sender)
{
        FindCard();

        int sec = ListBoxDataSector->ItemIndex;
        int mode = ComboBoxDataOpPwdType->ItemIndex;
        if (mode == USEKEYA || mode == USEKEYB)
        {
                AnsiString sPassword = EditDataOpPassword->Text.Trim();
                if (!sPassword.IsEmpty())
                {
                        rc_load_key(mode, sec, HexStringToBytes(sPassword));
                }
        }
        else
        {
                rc_authentication(mode, sec);
        }

        BYTE buf[BUF_SIZE];
        memset(buf, 0x0, BUF_SIZE);

        if (EditDataBlock0->Enabled && !EditDataBlock0->Text.IsEmpty())
        {
                rc_write(4*sec, buf);
                rc_beep();
        }

        if (!EditDataBlock1->Text.IsEmpty())
        {
                rc_write(4*sec+1, buf);
                rc_beep();
        }

        if (!EditDataBlock2->Text.IsEmpty())
        {
                rc_write(4*sec+2, buf);
                rc_beep();
        }

        MainRichEdit->Lines->Append("ʼɹ");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ListBoxDataSectorClick(TObject *Sender)
{
        EditDataBlock0->Clear();
        EditDataBlock1->Clear();
        EditDataBlock2->Clear();
        EditDataBlock3->Clear();

        if (ListBoxDataSector->ItemIndex == 0)
        {
                EditDataBlock0->Enabled = false;
        }
        else
        {
                EditDataBlock0->Enabled = true;
        }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ListBoxValueSectorClick(TObject *Sender)
{
        EditValueBlock0->Clear();
        EditValueBlock1->Clear();
        EditValueBlock2->Clear();
        EditValueBlock3->Clear();

        if (ListBoxValueSector->ItemIndex == 0)
        {
                EditValueBlock0->Enabled = false;
        }
        else
        {
                EditValueBlock0->Enabled = true;
        }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonValueBlockReadClick(TObject *Sender)
{
        FindCard();

        int sec = ListBoxValueSector->ItemIndex;
        int mode = ComboBoxValueOpPwdType->ItemIndex;
        if (mode == USEKEYA || mode == USEKEYB)
        {
                AnsiString sPassword = EditValueOpPassword->Text.Trim();
                if (!sPassword.IsEmpty())
                {
                        rc_load_key(mode, sec, HexStringToBytes(sPassword));
                }
        }
        else
        {
                rc_authentication(mode, sec);
        }

        BYTE buf[16];

        memset(buf, 0, BUF_SIZE);
        rc_read(4*sec, buf);
        EditValueBlock0->Text = BytesToString(buf, BUF_SIZE);
        rc_beep();

        memset(buf, 0, BUF_SIZE);
        rc_read(4*sec+1, buf);
        EditValueBlock1->Text = BytesToString(buf, BUF_SIZE);
        rc_beep();

        memset(buf, 0, BUF_SIZE);
        rc_read(4*sec+2, buf);
        EditValueBlock2->Text = BytesToString(buf, BUF_SIZE);
        rc_beep();

        memset(buf, 0, BUF_SIZE);
        rc_read(4*sec+3, buf);
        EditValueBlock3->Text = BytesToString(buf, BUF_SIZE);
        rc_beep();

        MainRichEdit->Lines->Append("ֵɹ");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonValueBlockIncClick(TObject *Sender)
{
        if (EditValueOpValue->Text.IsEmpty())
        {
                Application->MessageBox("ȷĲֵ", "ʾ", MB_ICONINFORMATION);
                return;
        }

        int sec = ListBoxValueSector->ItemIndex;
        int value = StrToInt("0x" + EditValueOpValue->Text);

        rc_increment(4*sec, value);
        rc_beep();

        rc_increment(4*sec+1, value);
        rc_beep();

        rc_increment(4*sec+2, value);
        rc_beep();

        MainRichEdit->Lines->Append("ֵɹ");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonValueBlockDecClick(TObject *Sender)
{
        if (EditValueOpValue->Text.IsEmpty())
        {
                Application->MessageBox("ȷĲֵ", "ʾ", MB_ICONINFORMATION);
                return;
        }

        int sec = ListBoxValueSector->ItemIndex;
        int value = StrToInt("0x" + EditValueOpValue->Text);

        rc_decrement(4*sec, value);
        rc_beep();

        rc_decrement(4*sec+1, value);
        rc_beep();

        rc_decrement(4*sec+2, value);
        rc_beep();

        MainRichEdit->Lines->Append("ֵɹ");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonValueBlockInitClick(TObject *Sender)
{
        FindCard();

        int sec = ListBoxValueSector->ItemIndex;
        int mode = ComboBoxValueOpPwdType->ItemIndex;
        if (mode == USEKEYA || mode == USEKEYB)
        {
                AnsiString sPassword = EditValueOpPassword->Text.Trim();
                if (!sPassword.IsEmpty())
                {
                        rc_load_key(mode, sec, HexStringToBytes(sPassword));
                }
        }
        else
        {
                rc_authentication(mode, sec);
        }

        if (EditValueBlock0->Enabled && !EditValueBlock0->Text.IsEmpty())
        {
                rc_write(4*sec, GetInitBytes(4*sec, 0));
                rc_beep();
        }

        if (!EditValueBlock1->Text.IsEmpty())
        {
                rc_write(4*sec+1, GetInitBytes(4*sec+1, 0));
                rc_beep();
        }

        if (!EditValueBlock2->Text.IsEmpty())
        {
                rc_write(4*sec+2, GetInitBytes(4*sec+2, 0));
                rc_beep();
        }

        MainRichEdit->Lines->Append("ʼֵɹ");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Menu_Password_DownloadClick(TObject *Sender)
{
        TKeyOptionForm *from = new TKeyOptionForm(this);
        from->ShowModal();
        delete from;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Menu_Password_ChangeClick(TObject *Sender)
{
        TKeyOptionForm *from = new TKeyOptionForm(this);
        from->ShowModal();
        delete from;        
}
//---------------------------------------------------------------------------

