//---------------------------------------------------------------------------

#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *StatusBar1;
        TPageControl *PageControl1;
        TTabSheet *TabSheetDevice;
        TRichEdit *MainRichEdit;
        TTabSheet *TabSheetData;
        TTabSheet *TabSheetValue;
        TMainMenu *MainMenu1;
        TMenuItem *Menu_File;
        TMenuItem *Menu_File_Exit;
        TMenuItem *Menu_Help;
        TMenuItem *Menu_Help_About;
        TTabSheet *TabSheet4;
        TTabSheet *TabSheet5;
        TGroupBox *GroupBoxCom;
        TComboBox *ComboBoxPort;
        TComboBox *ComboBoxBaud;
        TButton *ButtonClose;
        TButton *ButtonOpen;
        TLabel *LabelPort;
        TLabel *LabelBaud;
        TGroupBox *GroupBoxInfo;
        TGroupBox *GroupBoxOther;
        TLabel *LabelSoftware;
        TLabel *LabelHardware;
        TLabel *LabelCardSN;
        TLabel *LabelSoftwareValue;
        TLabel *LabelHardwareValue;
        TLabel *LabelCardSNValue;
        TComboBox *ComboBoxFindMode;
        TLabel *LabelFindMode;
        TLabel *LabelTimeOut;
        TEdit *EditTimeOut;
        TLabel *LabelTimeOutUnit;
        TButton *ButtonFindCard;
        TButton *ButtonAntiCollision;
        TButton *ButtonSelectCard;
        TButton *ButtonHaltCard;
        TGroupBox *GroupBoxDataSector;
        TListBox *ListBoxDataSector;
        TGroupBox *GroupBoxDataBlock;
        TGroupBox *GroupBoxDataOp;
        TLabel *LabelDataBlock0;
        TEdit *EditDataBlock0;
        TLabel *LabelDataBlock1;
        TEdit *EditDataBlock1;
        TLabel *LabelDataBlock2;
        TEdit *EditDataBlock2;
        TLabel *LabelDataBlock3;
        TEdit *EditDataBlock3;
        TLabel *LabelDataOpPwdType;
        TComboBox *ComboBoxDataOpPwdType;
        TButton *ButtonDataBlockRead;
        TButton *ButtonDataBlockWrite;
        TButton *ButtonDataBlockInit;
        TEdit *EditDataOpPassword;
        TGroupBox *GroupBoxValueSector;
        TListBox *ListBoxValueSector;
        TGroupBox *GroupBoxValueBlock;
        TLabel *LabelValueBlock0;
        TLabel *LabelValueBlock1;
        TLabel *LabelValueBlock2;
        TLabel *LabelValueBlock3;
        TEdit *EditValueBlock0;
        TEdit *EditValueBlock1;
        TEdit *EditValueBlock2;
        TEdit *EditValueBlock3;
        TButton *ButtonValueBlockRead;
        TGroupBox *GroupBoxValueOp;
        TLabel *LabelValueOpPwdType;
        TComboBox *ComboBoxValueOpPwdType;
        TEdit *EditValueOpPassword;
        TLabel *LabelValueOpValue;
        TEdit *EditValueOpValue;
        TButton *ButtonValueBlockInc;
        TButton *ButtonValueBlockDec;
        TButton *ButtonValueBlockInit;
        TMenuItem *Menu_Password;
        TMenuItem *Menu_Password_Download;
        TMenuItem *Menu_Password_Change;
        TCheckBox *CheckBox1;
        TLabel *LabelDataOpPwd;
        TLabel *LabelValueOpPwd;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall ButtonOpenClick(TObject *Sender);
        void __fastcall ButtonCloseClick(TObject *Sender);
        void __fastcall ButtonFindCardClick(TObject *Sender);
        void __fastcall ButtonAntiCollisionClick(TObject *Sender);
        void __fastcall ButtonSelectCardClick(TObject *Sender);
        void __fastcall ButtonHaltCardClick(TObject *Sender);
        void __fastcall Menu_File_ExitClick(TObject *Sender);
        void __fastcall Menu_Help_AboutClick(TObject *Sender);
        void __fastcall ButtonDataBlockReadClick(TObject *Sender);
        void __fastcall ButtonDataBlockWriteClick(TObject *Sender);
        void __fastcall ButtonDataBlockInitClick(TObject *Sender);
        void __fastcall ListBoxDataSectorClick(TObject *Sender);
        void __fastcall ListBoxValueSectorClick(TObject *Sender);
        void __fastcall ButtonValueBlockReadClick(TObject *Sender);
        void __fastcall ButtonValueBlockIncClick(TObject *Sender);
        void __fastcall ButtonValueBlockDecClick(TObject *Sender);
        void __fastcall ButtonValueBlockInitClick(TObject *Sender);
        void __fastcall Menu_Password_DownloadClick(TObject *Sender);
        void __fastcall Menu_Password_ChangeClick(TObject *Sender);
private:	// User declarations
        void __fastcall Open();
        void __fastcall Exit();
        void __fastcall FindCard();
        void __fastcall WriteCardBlock(int block);

public:		// User declarations
        __fastcall TMainForm(TComponent* Owner);

};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;

BYTE* HexStringToBytes(AnsiString s);
//---------------------------------------------------------------------------
#endif
